<?php
if(is_admin()){
     return false;
}
require_once $GLOBALS['AM_CLS']->AmPath['BaseCommon'].'Lib.Common.php';
require_once $GLOBALS['AM_CLS'] -> AmPath['ExtConf'].'Init.php';

if(!isset($GLOBALS['AM_CLS']->AmData['ExtConf']['analy']['analy-flag']) || $GLOBALS['AM_CLS']->AmData['ExtConf']['analy']['analy-flag'] != '1'){
     return false;
}



#过滤不需要统计的
$ClientIPv4 = AmGetIp();
if($ClientIPv4 == '127.0.0.2'){
     return false;
}
if(AmLibIsIPv4($ClientIPv4) == true && isset($GLOBALS['AM_CLS']->AmData['ExtConf']['analy']['analy-ignore'])){
	 $ClientIPv4Int = bindec( decbin( ip2long($ClientIPv4)) );
	 $arr = $GLOBALS['AM_CLS']->AmData['ExtConf']['analy']['analy-ignore'];
	 for($i=0;$i<count($arr);$i++){
		  if(isset($arr[$i][0]) && isset($arr[$i][1]) && $ClientIPv4Int >= $arr[$i][0] && $ClientIPv4Int <= $arr[$i][1]){
			   return false;
		  }
	 }
}





$GLOBALS['AM_CLS'] -> Analysis['Note'] =false;
$GLOBALS['AM_CLS'] -> Analysis['ClientIPv4'] = @AmGetIp();
if(AmLibIsIPv4($GLOBALS['AM_CLS'] -> Analysis['ClientIPv4']) == false){
	 $GLOBALS['AM_CLS'] -> Analysis['Note'] .= 'IPv4:'.$GLOBALS['AM_CLS'] -> Analysis['ClientIPv4'].';';
     $GLOBALS['AM_CLS'] -> Analysis['ClientIPv4'] = 0;
}else{
     $GLOBALS['AM_CLS'] -> Analysis['ClientIPv4'] = bindec( decbin( ip2long($GLOBALS['AM_CLS'] -> Analysis['ClientIPv4'])) );;
}
if(isset($_SERVER['HTTP_USER_AGENT'])){
	 $GLOBALS['AM_CLS'] -> Analysis['ClientAgent'] = $_SERVER['HTTP_USER_AGENT'];
	 if(strlen($GLOBALS['AM_CLS'] -> Analysis['ClientAgent']) > 1024){
	      $GLOBALS['AM_CLS'] -> Analysis['ClientAgent'] = substr($GLOBALS['AM_CLS'] -> Analysis['ClientAgent'],0,1024);
	 }
}else{
	 $GLOBALS['AM_CLS'] -> Analysis['ClientAgent'] = '';
}
$GLOBALS['AM_CLS'] -> Analysis['RequestTime'] = time();

if(isset($_SERVER['HTTP_REFERER'])){
	 $GLOBALS['AM_CLS'] -> Analysis['ClientReferer'] = $_SERVER['HTTP_REFERER'];
	 if(strlen($GLOBALS['AM_CLS'] -> Analysis['ClientReferer']) > 1024){
	      $GLOBALS['AM_CLS'] -> Analysis['ClientReferer'] = substr($GLOBALS['AM_CLS'] -> Analysis['ClientReferer'],0,1024);
	 }
}else{
	 $GLOBALS['AM_CLS'] -> Analysis['ClientReferer'] = '';
}


if(isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])){
	 $GLOBALS['AM_CLS'] -> Analysis['ClientLanguage'] = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
	 if(strlen($GLOBALS['AM_CLS'] -> Analysis['ClientLanguage']) > 1024){
	      $GLOBALS['AM_CLS'] -> Analysis['ClientLanguage'] = substr($GLOBALS['AM_CLS'] -> Analysis['ClientLanguage'],0,1024);
	 }
}else{
	 $GLOBALS['AM_CLS'] -> Analysis['ClientLanguage'] = '';
}
$GLOBALS['AM_CLS'] -> Analysis['Url'] = ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') || (isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https')) ? 'https://' : 'http://';
$GLOBALS['AM_CLS'] -> Analysis['Url'] .= $_SERVER['SERVER_NAME']; 
if(isset($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT'] != '80'){
$GLOBALS['AM_CLS'] -> Analysis['Url'] .= ':'.$_SERVER['SERVER_PORT']; 
}
$GLOBALS['AM_CLS'] -> Analysis['Url'] .= $_SERVER["REQUEST_URI"]; 

$GLOBALS['AM_CLS'] -> Analysis['Url'] = urldecode($GLOBALS['AM_CLS'] -> Analysis['Url']);


if(isset($_SERVER["REDIRECT_STATUS"])){
     $GLOBALS['AM_CLS'] -> Analysis['HttpCode'] = $_SERVER["REDIRECT_STATUS"]; 
}else{
     $GLOBALS['AM_CLS'] -> Analysis['HttpCode'] = ''; 
}


$GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'other';
$GLOBALS['AM_CLS'] -> Analysis['WpValue'] = false;



#http://pangbu.com/which-type-of-certain-webpage/


global $paged;
$GLOBALS['AM_CLS'] -> Analysis['WpPage'] = $paged;
if(is_home()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Home';
	 global $paged;
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = $paged;
}else if(is_single()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Post';
	 global $post;
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = $post -> ID;
}else if(is_search()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Search';
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = get_search_query();
}else if(is_404()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Error404';
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = '';
}else if(is_category()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Category';
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = the_category_ID(false);
}else if(is_tag()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Tag';
     $current_tag = single_tag_title('', false);
     $tags = get_term_by('name',$current_tag,'post_tag');
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = $tags -> term_id;
}else if(is_page()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Page';
	 global $post;
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = $post -> ID;
}else if(is_archive()){
     $GLOBALS['AM_CLS'] -> Analysis['WpType'] = 'Archive';
	 global $post;
     $GLOBALS['AM_CLS'] -> Analysis['WpValue'] = '';
}





global $table_prefix;
$sql = '';
$sql .= 'Insert Into'.PHP_EOL;
$sql .= $table_prefix.'am_analysis'.PHP_EOL;
$sql .= ' Set '.PHP_EOL;
$sql .= 'Note="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['Note']).'",'.PHP_EOL;
$sql .= 'ClientIPv4="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['ClientIPv4']).'",'.PHP_EOL;
$sql .= 'ClientAgent="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['ClientAgent']).'",'.PHP_EOL;
$sql .= 'RequestTime="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['RequestTime']).'",'.PHP_EOL;
$sql .= 'ClientReferer="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['ClientReferer']).'",'.PHP_EOL;
$sql .= 'ClientLanguage="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['ClientLanguage']).'",'.PHP_EOL;
$sql .= 'Url="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['Url']).'",'.PHP_EOL;
$sql .= 'HttpCode="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['HttpCode']).'",'.PHP_EOL;
$sql .= 'WpType="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['WpType']).'",'.PHP_EOL;
$sql .= 'WpValue="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['WpValue']).'",'.PHP_EOL;
$sql .= 'WpPage="'.addslashes($GLOBALS['AM_CLS'] -> Analysis['WpPage']).'"'.PHP_EOL;

$GLOBALS['AM_CLS']->MysqlUpdate($sql);

return true;
?>